/***************************************************
* PIC24FJ64GA002 family 
*  @\gJE^
*  \͏^t\F162s
*  ^C}4 : m1b̃C^[o^C}ŁÅ荞݂Ń^C}PQ[g
*  ^C}P5:gJE^Ń\tgEFAŌ32rbgƂĈ
*         ^C}P͊ÓiT1CK)Ŕ񓯊JE^A^C}5̓\tgEFAŃJEg
*  ^C}2 : OC1p^C}
*  OC1  : 1/1܂1/640PWM(o͂RP7)
*  ^C}3 : OC2p^C}(T3CKRP8sɊ蓖)
*  OC2  : PWMo(o͂RP6)
****************************************************/
#include "p24FJ32GA002.h"
#include "LCD_Lib3.h"					// t\탉Cu
// RtBM[V rbg̐ݒ
_CONFIG1( JTAGEN_OFF & GCP_OFF & GWRP_OFF & BKBUG_ON 
		& COE_OFF & FWDTEN_OFF & ICS_PGx1 ) 
// 12.8MHz External Oscillator
_CONFIG2( IESO_OFF & FNOSC_PRI & FCKSM_CSDCMD 
		& OSCIOFNC_OFF & IOL1WAY_ON & I2C1SEL_PRI & POSCMOD_EC)
/// ֐vg^CsO
void ltostring(char digit, unsigned long data, char *buffer);
void Pulse(void);
void Peri_Init(void);
/// LCDbZ[WpŒf[^
const char MsgStart[] = "Start!";
const char MsgOut[][17] = {
	{"Output Off      "}, {"Output = 0.01Hz "},
	{"Output = 0.1Hz  "}, {"Output = 1Hz    "},
	{"Output = 10Hz   "}, {"Output = 100Hz  "},
	{"Output = 1kHz   "}, {"Output = 10kHz  "},
	{"Output = 100kHz "}, {"Output = 200kHz "},
	{"Output = 400kHz "}, {"Output = 800kHz "},
	{"Output = 1.6MHz "}, {"Output = 3.2MHz "},
	{"Output =        "}, {"Output =        "}};
/// O[oϐ錾
//// g\pbZ[Wobt@
char MsgData[] 	= "Freq= xxxxxxxxHz";
unsigned char StateFlag;				// Xe[gϐ
unsigned long Result;					// 茋ʃf[^
unsigned int SWState,Old_SW;			// g؂ւXCb`f[^
/********************************
* C֐
********************************/
int main(void)
{
	CLKDIV = 0;							// NbN1/1
	/// |[gݒ
    AD1PCFG = 0xffff;					// ׂăfBW^|[gƂ
	TRISA = 0xFFFF;						// |[gAׂē
	TRISB = 0x00AF;						// RB0-3,5,7
	PORTB = 0x03FF;
	/// XCb`pvAbv̗L
	CNPU1 = 0x003C;
	/// stݒ
	RPINR3bits.T3CKR = 7;				// T3CKRP7
	RPOR4bits.RP8R = 18;				// OC1o͂RP8
	RPOR3bits.RP6R = 19;				// OC2o͂RP6
	/// ӃW[̏ݒ
	Peri_Init();
	/// JnbZ[W\
	lcd_init();							// LCD
	lcd_clear();						// S
	lcd_str((char *)MsgStart);
	StateFlag = 0;						// Xe[g
	////// C[vŌvl\  ////////////	
	while(1)
	{
		//// ^C}P̃JEgI[o[t[Ń^C}5JEgAbv
		if(IFS0bits.T1IF == 1){				// ^C}PI[o[t[H
			IFS0bits.T1IF = 0;
			TMR5++;							// ^C}5JEgAbv
		}
		///// g\
		if(StateFlag == 2)					// I?
		{
			Result = TMR5 * 0x10000 + TMR1;	// l
			ltostring(8, Result, MsgData+6);// lASCIIɕϊobt@֊i[
			lcd_cmd(0x80);					// 1sڂ̐擪
			lcd_str(MsgData);				// vl\
			TMR1 = 0;						// ̑菀
			TMR5 = 0;						// JE^NA
			lcd_cmd(0xC0);					// LCD2sڂ̐擪
			lcd_str((char *)&MsgOut[SWState][0]);// pXo͎g\
			StateFlag = 0;					// Xe[gϐ 
		}
		//// pXo͐
		Pulse();
	}
}
/********************************
* ^C}4荞ݏim1bC^[o
*********************************/
void __attribute__((interrupt, auto_psv)) _T4Interrupt(void)
{
	IFS1bits.T4IF = 0;					// 荞݃tONA
//	LATBbits.LATB4 = !LATBbits.LATB4;	// fobOpLED_
	if(StateFlag == 0){					// ԂH
		Nop();							// Ԓp
		T1CONbits.TON = 1;				// gJEgJn
		StateFlag = 1;					// Xe[gXV
	}
	else{								// v̏ꍇ
		T1CONbits.TON = 0;				// gJEg~
		StateFlag = 2;					// Xe[gXV
	}
}
/***************************
*  ӃW[֐
****************************/
void Peri_Init(void)
{
	/// ^C}P̐ݒ : ONbN, 1/1, 񓯊
	T1CON = 0b0000000000000010;
	TMR1 = 0;	
	/// ^C}2ݒ : NbN, 1/1, 10kHz
	T2CON = 0b1000000000000000;			// 1/1
	PR2 = 639;							// l=10kHz
	/// ^C}3ݒ F ONbN(OC1), 1/1, 1Hz
	T3CON = 0b1000000000000010;
	PR3 = 9999; 						// l=1sec
	/// ^C}4ݒ:NbN, 1/256, FCY = 6.4MHz@1bo
	T4CON = 0b1000000000110000;
	PR4 = 24999;						// 1b
	IPC6bits.T4IP = 5;					// 荞݃x=5
	IFS1bits.T4IF = 0;
	IEC1bits.T4IE = 1;					// 荞݋
	/// ^C}5ݒ@\tgEFAJE^
	T5CON = 0b0000000000000010;
	/// OC1ݒ : PWM[hA^C}2gp
	OC1CON = 0x06;
	OC1RS = (PR2+1) / 2;				// f[eB50%
	/// OC2ݒ@: PWM[hA^C}Rgp
	OC2CON = 0x0E;
	OC2RS = (PR3+1) / 2;				// V[eB50%
}

/*******************************
* lASCIIɕϊ֐
********************************/
void ltostring(char digit, unsigned long data, char *buffer)
{
	char i;	
	buffer += digit;					// ̍Ō
	for(i=digit; i>0; i--) {			// ŉʌʂ
		buffer--;						// |C^[P
		*buffer = (data % 10) + '0';	// ̌l𕶎ɂĊi[
		data = data / 10;				// -1
	}
}
/***************************
* pXo͐֐
****************************/
void Pulse(void)
{
	///XCb`̓ǂݍ݂ĎgIR[hɕϊ
	SWState = (~PORTA & 3) + (~(PORTB << 2) & 0x0C);
	if(SWState != Old_SW)
	{
		Old_SW = SWState;						// XCb`ԍXV
		TMR2 = 0;								// ^C}Zbg
		TMR3 = 0;
		switch(SWState)
		{
		case 0:	/// Off
				T3CON = 0b0000000000000010;		// ^C}It
				break;
		case 1: ///  0.01Hz
				T3CON = 0b1000000000000010;		// O 1/1
				PR2 = 31999;					// 200Hz
				PR3 = 19999;					// 0.01Hz
				break;
		case 2: ///  0.1Hz
				T3CON = 0b1000000000000010;		// O
				PR2 = 3199;						// 2kHz
				PR3 = 19999;					// 0.1Hz
				break;
		case 3: ///  1Hz
				T3CON = 0b1000000000000010;		// O
				PR2 = 319;						// 20kHz
				PR3 = 19999;					// 1Hz
				break;
		case 4: ///  10Hz
				T3CON = 0b1000000000000010;		// O
				PR2 = 319;						// 20kHz
				PR3 = 1999;						// 10Hz
				break;
		case 5: ///  100Hz
				T3CON = 0b1000000000000010;		// O
				PR2 = 319;						// 20kHz
				PR3 = 199;						// 100Hz
				break;
		case 6: ///  1kHz
				T3CON = 0b1000000000000010;		// O
				PR2 = 31;						// 200kHz
				PR3 = 199;						// 1kHz
				break;
		case 7: ///  10kHz
				T3CON = 0b1000000000000010;		// O
				PR2 = 31;						// 200kHz
				PR3 = 19;						// 10kHz 
				break;
		case 8: ///  100kHz
				T3CON = 0b1000000000000000;		// A1/1
				PR3 = 63;
				break;
		case 9: ///  200kHz
				T3CON = 0b1000000000000000;		// A1/1
				PR3 = 31;
				break;
		case 0xA: ///  400kHz
				T3CON = 0b1000000000000000;		// A1/1
				PR3 = 15;
				break;
		case 0xB: ///  800kHz
				T3CON = 0b1000000000000000;		// A1/1
				PR3 = 7;
				break;
		case 0xC: ///  1.6MHz
				T3CON = 0b1000000000000000;		// A1/1
				PR3 = 3;
				break;
		case 0xD: ///  3.2MHz
				T3CON = 0b1000000000000000;		// A1/1
				PR3 = 1;
				break;
		default: /// Off 
				T3CON = 0b0000000000000010;		// Ext 1/1
				break;
		}
		OC1RS = (PR2+1) / 2;
		OC2RS = (PR3+1) / 2;			// Duty 50% 
	}
}
