/****************************************************
*  t\퐧䃉Cu@for PIC24FJV[Y
*  ֐͈ȉ
*    delay_us()    ----- usecPʃfBC
*    delay_ms()    ----- msecPʃfBC
*    lcd_init()    ----- 
*    lcd_cmd(cmd)  ----- R}ho
*    lcd_data(chr) ----- P\o
*    lcd_clear()   ----- S
*****************************************************/
#include "LCD_Lib3.h"

//////// f[^o̓Tu֐
void lcd_out(char code, char flag){
	// Set upper 4 bits Data on LATB12-LATB15
	LCD_DATA = (LCD_DATA & 0x0FFF) | ((unsigned int)(code & 0xF0)<<8); 
	if (flag == 0)
		LCD_RS = 1;			// \f[^̏ꍇ
	else
		LCD_RS = 0;			// R}hf[^̏ꍇ
	delay_us(1);			// ZbgAbvԊm		
	LCD_E = 1;				// E(STB)oHigh
	delay_us(1);			// pXm
	LCD_E = 0;				// E(STB)oLow
}
/////// ֐
void lcd_init(void){
	delay_ms(20);
	lcd_out(0x03, 1);		// 8bit mode set
	delay_ms(5);
	lcd_out(0x03, 1);		// 8bit mode set
	delay_ms(1);
	lcd_out(0x03, 1);		// 8bit mode set
	delay_ms(1);
	lcd_out(0x02, 1);		// 4bit mode set
	delay_ms(1);
	lcd_cmd(0x2E);			// DL=0 4bit mode
	lcd_cmd(0x08);			// display off C=D=B=0
	lcd_cmd(0x0D);			// display on B=D=1 C=0
	lcd_cmd(0x06);			// entry I/D=1 S=0
	lcd_cmd(0x02);			// cursor home
}
//////// P\֐
void lcd_data(char asci){
	lcd_out(asci, 0);		// ʂSrbgo
	lcd_out(asci<<4, 0);	// ʂSrbgo
	delay_us(50);			// 50sec҂
}
/////// R}ho͊֐
void lcd_cmd(char cmd){
	lcd_out(cmd, 1);		// ʂSrbgo
	lcd_out(cmd<<4, 1);		// ʂSrbgo
	if((cmd & 0x03) != 0)	// Clear homȅꍇ
		delay_ms(2);		// 2msec҂
	else
		delay_us(50);		// 50usec҂
}
/////// S֐
void lcd_clear(void){
	lcd_cmd(0x01);			// R}ho
	delay_ms(15);			// 15msec҂
}
/////// o͊֐
void lcd_str(char *str){
	while(*str != 0x00){	// ̏I蔻
		lcd_data(*str);		// Po
		str++;				// |C^{P
	}
}

//////// usecPʃfBC֐
void delay_us(int usec){
	usec = (int)(CLOCK*usec)/ 10;
	while(usec)	{
		asm("NOP");
		asm("NOP");
		asm("NOP");
		asm("NOP");
		asm("NOP");					
		usec--;
	}
}
/////// msecPʃfBC֐
void delay_ms(int msec){
	int i;
	for(i=0; i< msec; i++)
		delay_us(1000);
}
